diff -urpN ksmbd-tools-3.1.0/usmbd/rpc.c ksmbd-tools-3.1.0.new/usmbd/rpc.c
--- ksmbd-tools-3.1.0/usmbd/rpc.c	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/usmbd/rpc.c	2020-01-26 13:58:13.876726005 +0400
@@ -1,4 +1,4 @@
-// SPDX-License-Identifier: GPL-2.0-or-later
+// SPDX-License-Identi	fier: GPL-2.0-or-later
 /*
  *   Copyright (C) 2018 Samsung Electronics Co., Ltd.
  *
@@ -7,17 +7,17 @@
 
 #include <memory.h>
 #include <endian.h>
-#include <glib.h>
 #include <errno.h>
 #include <linux/usmbd_server.h>
 
 #include <rpc.h>
 #include <rpc_srvsvc.h>
 #include <rpc_wkssvc.h>
+#include <pthread.h>
 #include <usmbdtools.h>
 
-static GHashTable	*pipes_table;
-static GRWLock		pipes_table_lock;
+static struct LIST *pipes_table;
+static pthread_rwlock_t pipes_table_lock;
 
 /*
  * Version 2.0 data representation protocol
@@ -35,31 +35,31 @@ static GRWLock		pipes_table_lock;
  * Interface: SRVSVC UUID: 4b324fc8-1670-01d3-1278-5a47bf6ee188
  */
 struct dcerpc_syntax_table {
-	struct dcerpc_syntax	syn;
-	int			ack_result;
+	struct dcerpc_syntax syn;
+	int ack_result;
 };
 
 static struct dcerpc_syntax_table known_syntaxes[] = {
 	{
-		.syn.uuid.time_low = 0x8a885d04,
-		.syn.uuid.time_mid = 0x1ceb,
-		.syn.uuid.time_hi_and_version = 0x11c9,
-		.syn.uuid.clock_seq = {0x9f, 0xe8},
-		.syn.uuid.node = {0x8, 0x0, 0x2b, 0x10, 0x48, 0x60},
-		.syn.ver_major = 0x2,
-		.syn.ver_minor = 0x0,
-		.ack_result = DCERPC_BIND_ACK_RES_ACCEPT,
-	},
+	 .syn.uuid.time_low = 0x8a885d04,
+	 .syn.uuid.time_mid = 0x1ceb,
+	 .syn.uuid.time_hi_and_version = 0x11c9,
+	 .syn.uuid.clock_seq = { 0x9f, 0xe8},
+	 .syn.uuid.node = { 0x8, 0x0, 0x2b, 0x10, 0x48, 0x60},
+	 .syn.ver_major = 0x2,
+	 .syn.ver_minor = 0x0,
+	 .ack_result = DCERPC_BIND_ACK_RES_ACCEPT,
+	  },
 	{
-		.syn.uuid.time_low = 0x6CB71C2C,
-		.syn.uuid.time_mid = 0x9812,
-		.syn.uuid.time_hi_and_version = 0x4540,
-		.syn.uuid.clock_seq = {0x0, 0x0},
-		.syn.uuid.node = {0x0, 0x0, 0x0, 0x0, 0x0, 0x0},
-		.syn.ver_major = 0x1,
-		.syn.ver_minor = 0x0,
-		.ack_result = DCERPC_BIND_ACK_RES_NEGOTIATE_ACK,
-	},
+	 .syn.uuid.time_low = 0x6CB71C2C,
+	 .syn.uuid.time_mid = 0x9812,
+	 .syn.uuid.time_hi_and_version = 0x4540,
+	 .syn.uuid.clock_seq = { 0x0, 0x0},
+	 .syn.uuid.node = { 0x0, 0x0, 0x0, 0x0, 0x0, 0x0},
+	 .syn.ver_major = 0x1,
+	 .syn.ver_minor = 0x0,
+	 .ack_result = DCERPC_BIND_ACK_RES_NEGOTIATE_ACK,
+	  },
 };
 
 /*
@@ -99,9 +99,9 @@ static struct usmbd_rpc_pipe *rpc_pipe_l
 {
 	struct usmbd_rpc_pipe *pipe;
 
-	g_rw_lock_reader_lock(&pipes_table_lock);
-	pipe = g_hash_table_lookup(pipes_table, &id);
-	g_rw_lock_reader_unlock(&pipes_table_lock);
+	pthread_rwlock_wrlock(&pipes_table_lock);
+	pipe = list_get(&pipes_table, id);
+	pthread_rwlock_unlock(&pipes_table_lock);
 
 	return pipe;
 }
@@ -137,8 +137,7 @@ static struct usmbd_dcerpc *dcerpc_alloc
 }
 
 static struct usmbd_dcerpc *dcerpc_ext_alloc(unsigned int flags,
-					     void *payload,
-					     int payload_sz)
+					     void *payload, int payload_sz)
 {
 	struct usmbd_dcerpc *dce;
 
@@ -179,16 +178,16 @@ static void __rpc_pipe_free(struct usmbd
 	rpc_pipe_reset(pipe);
 	if (pipe->dce)
 		dcerpc_free(pipe->dce);
-	g_array_free(pipe->entries, 1);
+	list_clear(&pipe->entries);
 	free(pipe);
 }
 
 static void rpc_pipe_free(struct usmbd_rpc_pipe *pipe)
 {
 	if (pipe->id != (unsigned int)-1) {
-		g_rw_lock_writer_lock(&pipes_table_lock);
-		g_hash_table_remove(pipes_table, &(pipe->id));
-		g_rw_lock_writer_unlock(&pipes_table_lock);
+		pthread_rwlock_wrlock(&pipes_table_lock);
+		list_remove(&pipes_table, pipe->id);
+		pthread_rwlock_unlock(&pipes_table_lock);
 	}
 
 	__rpc_pipe_free(pipe);
@@ -203,7 +202,7 @@ static struct usmbd_rpc_pipe *rpc_pipe_a
 		return NULL;
 
 	pipe->id = -1;
-	pipe->entries = g_array_new(0, 0, sizeof(void *));
+	list_init(&pipe->entries);
 	if (!pipe->entries) {
 		rpc_pipe_free(pipe);
 		return NULL;
@@ -220,28 +219,28 @@ static struct usmbd_rpc_pipe *rpc_pipe_a
 		return NULL;
 
 	pipe->id = id;
-	g_rw_lock_writer_lock(&pipes_table_lock);
-	ret = g_hash_table_insert(pipes_table, &(pipe->id), pipe);
-	g_rw_lock_writer_unlock(&pipes_table_lock);
-
+	pthread_rwlock_wrlock(&pipes_table_lock);
+	ret = list_add(&pipes_table, pipe, pipe->id);
 	if (!ret) {
 		pipe->id = (unsigned int)-1;
 		rpc_pipe_free(pipe);
 		pipe = NULL;
 	}
+	pthread_rwlock_unlock(&pipes_table_lock);
+
 	return pipe;
 }
 
-static void free_hash_entry(gpointer k, gpointer s, gpointer user_data)
+static void free_hash_entry(void *s, unsigned long long id, void *user_data)
 {
 	__rpc_pipe_free(s);
 }
 
 static void __clear_pipes_table(void)
 {
-	g_rw_lock_writer_lock(&pipes_table_lock);
-	g_hash_table_foreach(pipes_table, free_hash_entry, NULL);
-	g_rw_lock_writer_unlock(&pipes_table_lock);
+	pthread_rwlock_wrlock(&pipes_table_lock);
+	list_foreach(&pipes_table, free_hash_entry, NULL);
+	pthread_rwlock_unlock(&pipes_table_lock);
 }
 
 static void align_offset(struct usmbd_dcerpc *dce, size_t n)
@@ -305,7 +304,7 @@ int ndr_write_##name(struct usmbd_dcerpc
 	return 0;							\
 }
 
-NDR_WRITE_INT(int8,  __u8, htobe_n, htole_n);
+NDR_WRITE_INT(int8, __u8, htobe_n, htole_n);
 NDR_WRITE_INT(int16, __u16, htobe16, htole16);
 NDR_WRITE_INT(int32, __u32, htobe32, htole32);
 NDR_WRITE_INT(int64, __u64, htobe64, htole64);
@@ -324,7 +323,7 @@ type ndr_read_##name(struct usmbd_dcerpc
 	return ret;							\
 }
 
-NDR_READ_INT(int8,  __u8, betoh_n, letoh_n);
+NDR_READ_INT(int8, __u8, betoh_n, letoh_n);
 NDR_READ_INT(int16, __u16, be16toh, le16toh);
 NDR_READ_INT(int32, __u32, be32toh, le32toh);
 NDR_READ_INT(int64, __u64, be64toh, le64toh);
@@ -384,9 +383,9 @@ int ndr_read_bytes(struct usmbd_dcerpc *
 
 int ndr_write_vstring(struct usmbd_dcerpc *dce, char *value)
 {
-	gchar *out;
-	gsize bytes_read = 0;
-	gsize bytes_written = 0;
+	char *out;
+	size_t bytes_read = 0;
+	size_t bytes_written = 0;
 
 	size_t raw_len;
 	char *raw_value = value;
@@ -407,8 +406,7 @@ int ndr_write_vstring(struct usmbd_dcerp
 			     raw_len,
 			     charset,
 			     USMBD_CHARSET_DEFAULT,
-			     &bytes_read,
-			     &bytes_written);
+			     &bytes_read, &bytes_written);
 	if (!out)
 		return -EINVAL;
 
@@ -428,21 +426,21 @@ int ndr_write_vstring(struct usmbd_dcerp
 	ret |= ndr_write_bytes(dce, out, bytes_written);
 	auto_align_offset(dce);
 
-	g_free(out);
+	free(out);
 	return ret;
 }
 
 char *ndr_read_vstring(struct usmbd_dcerpc *dce)
 {
-	gchar *out;
-	gsize bytes_read = 0;
-	gsize bytes_written = 0;
+	char *out;
+	size_t bytes_read = 0;
+	size_t bytes_written = 0;
 
 	size_t raw_len;
 	int charset = USMBD_CHARSET_UTF16LE;
 
 	raw_len = ndr_read_int32(dce);
-	ndr_read_int32(dce); /* read in offset */
+	ndr_read_int32(dce);	/* read in offset */
 	ndr_read_int32(dce);
 
 	if (!(dce->flags & USMBD_DCERPC_LITTLE_ENDIAN))
@@ -459,9 +457,7 @@ char *ndr_read_vstring(struct usmbd_dcer
 	out = usmbd_gconvert(PAYLOAD_HEAD(dce),
 			     raw_len * 2,
 			     USMBD_CHARSET_DEFAULT,
-			     charset,
-			     &bytes_read,
-			     &bytes_written);
+			     charset, &bytes_read, &bytes_written);
 	if (!out)
 		return NULL;
 
@@ -528,9 +524,8 @@ static int __max_entries(struct usmbd_dc
 
 	current_size = 0;
 	for (i = 0; i < pipe->num_entries; i++) {
-		gpointer entry;
+		void *entry = list_get(&pipe->entries, i);
 
-		entry = g_array_index(pipe->entries,  gpointer, i);
 		current_size += dce->entry_size(dce, entry);
 
 		if (current_size < 4 * dce->payload_sz / 5)
@@ -547,21 +542,18 @@ int __ndr_write_array_of_structs(struct
 	int i;
 
 	for (i = 0; i < max_entry_nr; i++) {
-		gpointer entry;
+		void *entry = list_get(&pipe->entries, i);
 
-		entry = g_array_index(pipe->entries,  gpointer, i);
 		if (dce->entry_rep(dce, entry))
 			return USMBD_RPC_EBAD_DATA;
 	}
 
 	for (i = 0; i < max_entry_nr; i++) {
-		gpointer entry;
+		void *entry = list_get(&pipe->entries, i);
 
-		entry = g_array_index(pipe->entries,  gpointer, i);
 		if (dce->entry_data(dce, entry))
 			return USMBD_RPC_EBAD_DATA;
 	}
-
 	if (pipe->entry_processed) {
 		for (i = 0; i < max_entry_nr; i++)
 			pipe->entry_processed(pipe, 0);
@@ -627,10 +619,10 @@ int ndr_write_array_of_structs(struct us
 
 int rpc_init(void)
 {
-	pipes_table = g_hash_table_new(g_int_hash, g_int_equal);
+	list_init(&pipes_table);
 	if (!pipes_table)
 		return -ENOMEM;
-	g_rw_lock_init(&pipes_table_lock);
+	pthread_rwlock_init(&pipes_table_lock, NULL);
 	return 0;
 }
 
@@ -638,13 +630,12 @@ void rpc_destroy(void)
 {
 	if (pipes_table) {
 		__clear_pipes_table();
-		g_hash_table_destroy(pipes_table);
+		list_clear(&pipes_table);
 	}
-	g_rw_lock_clear(&pipes_table_lock);
+	pthread_rwlock_destroy(&pipes_table_lock);
 }
 
-static int dcerpc_hdr_write(struct usmbd_dcerpc *dce,
-			    struct dcerpc_header *hdr)
+static int dcerpc_hdr_write(struct usmbd_dcerpc *dce, struct dcerpc_header *hdr)
 {
 	ndr_write_int8(dce, hdr->rpc_vers);
 	ndr_write_int8(dce, hdr->rpc_vers_minor);
@@ -657,8 +648,7 @@ static int dcerpc_hdr_write(struct usmbd
 	return 0;
 }
 
-static int dcerpc_hdr_read(struct usmbd_dcerpc *dce,
-			   struct dcerpc_header *hdr)
+static int dcerpc_hdr_read(struct usmbd_dcerpc *dce, struct dcerpc_header *hdr)
 {
 	/* Common Type Header for the Serialization Stream */
 
@@ -908,7 +898,7 @@ static int dcerpc_bind_ack_return(struct
 
 	ndr_write_int16(dce, strlen(addr));
 	ndr_write_bytes(dce, addr, strlen(addr));
-	align_offset(dce, 4); /* [flag(NDR_ALIGN4)]    DATA_BLOB _pad1; */
+	align_offset(dce, 4);	/* [flag(NDR_ALIGN4)]    DATA_BLOB _pad1; */
 
 	num_trans = dce->bi_req.num_contexts;
 	ndr_write_int8(dce, num_trans);
@@ -968,7 +958,7 @@ static int dcerpc_bind_return(struct usm
 
 	if (!ack) {
 		pr_err("Unsupported transfer syntax\n");
-		ret =  dcerpc_bind_nack_return(pipe);
+		ret = dcerpc_bind_nack_return(pipe);
 	} else {
 		ret = dcerpc_bind_ack_return(pipe);
 	}
@@ -986,20 +976,19 @@ int rpc_restricted_context(struct usmbd_
 }
 
 int rpc_ioctl_request(struct usmbd_rpc_command *req,
-		      struct usmbd_rpc_command *resp,
-		      int max_resp_sz)
+		      struct usmbd_rpc_command *resp, int max_resp_sz)
 {
 	int ret;
 
 	ret = rpc_write_request(req, resp);
 	if (ret == USMBD_RPC_OK)
-		return rpc_read_request(req, resp, max_resp_sz);
+		ret = rpc_read_request(req, resp, max_resp_sz);
+
 	return ret;
 }
 
 int rpc_read_request(struct usmbd_rpc_command *req,
-		     struct usmbd_rpc_command *resp,
-		     int max_resp_sz)
+		     struct usmbd_rpc_command *resp, int max_resp_sz)
 {
 	int ret = USMBD_RPC_ENOTIMPLEMENTED;
 	struct usmbd_rpc_pipe *pipe;
@@ -1008,7 +997,7 @@ int rpc_read_request(struct usmbd_rpc_co
 	pipe = rpc_pipe_lookup(req->handle);
 	if (!pipe || !pipe->dce) {
 		pr_err("RPC: no pipe or pipe has no associated DCE [%d]\n",
-			req->handle);
+		       req->handle);
 		return USMBD_RPC_EBAD_FID;
 	}
 
@@ -1047,7 +1036,7 @@ int rpc_write_request(struct usmbd_rpc_c
 
 	if (pipe->num_entries)
 		pr_err("RPC: A call on unflushed pipe. Pending %d\n",
-			pipe->num_entries);
+		       pipe->num_entries);
 
 	dce = pipe->dce;
 	dce->rpc_req = req;
@@ -1092,8 +1081,7 @@ int rpc_open_request(struct usmbd_rpc_co
 
 	pipe->dce = dcerpc_ext_alloc(USMBD_DCERPC_LITTLE_ENDIAN |
 				     USMBD_DCERPC_ALIGN4,
-				     req->payload,
-				     req->payload_sz);
+				     req->payload, req->payload_sz);
 	if (!pipe->dce) {
 		rpc_pipe_free(pipe);
 		return USMBD_RPC_ENOMEM;
diff -urpN ksmbd-tools-3.1.0/usmbd/rpc_srvsvc.c ksmbd-tools-3.1.0.new/usmbd/rpc_srvsvc.c
--- ksmbd-tools-3.1.0/usmbd/rpc_srvsvc.c	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/usmbd/rpc_srvsvc.c	2020-01-26 13:58:13.876726005 +0400
@@ -7,7 +7,6 @@
 
 #include <memory.h>
 #include <endian.h>
-#include <glib.h>
 #include <errno.h>
 #include <linux/usmbd_server.h>
 
@@ -40,19 +39,19 @@ static int __share_type(struct usmbd_sha
 {
 	if (test_share_flag(share, USMBD_SHARE_FLAG_PIPE))
 		return SHARE_TYPE_IPC;
-	if (!g_ascii_strncasecmp(share->name, "IPC", strlen("IPC")))
+	if (!strncasecmp(share->name, "IPC", strlen("IPC")))
 		return SHARE_TYPE_IPC;
 	return SHARE_TYPE_DISKTREE;
 }
 
-static int __share_entry_size_ctr0(struct usmbd_dcerpc *dce, gpointer entry)
+static int __share_entry_size_ctr0(struct usmbd_dcerpc *dce, void *entry)
 {
 	struct usmbd_share *share = entry;
 
 	return strlen(share->name) * 2 + 4 * sizeof(__u32);
 }
 
-static int __share_entry_size_ctr1(struct usmbd_dcerpc *dce, gpointer entry)
+static int __share_entry_size_ctr1(struct usmbd_dcerpc *dce, void *entry)
 {
 	struct usmbd_share *share = entry;
 	int sz = 0;
@@ -71,33 +70,33 @@ static int __share_entry_size_ctr1(struc
  * An embedded reference pointer is represented in two parts, a 4 octet
  * value in place and a possibly deferred representation of the referent.
  */
-static int __share_entry_rep_ctr0(struct usmbd_dcerpc *dce, gpointer entry)
+static int __share_entry_rep_ctr0(struct usmbd_dcerpc *dce, void *entry)
 {
 	dce->num_pointers++;
-	return ndr_write_int32(dce, dce->num_pointers); /* ref pointer */
+	return ndr_write_int32(dce, dce->num_pointers);	/* ref pointer */
 }
 
-static int __share_entry_rep_ctr1(struct usmbd_dcerpc *dce, gpointer entry)
+static int __share_entry_rep_ctr1(struct usmbd_dcerpc *dce, void *entry)
 {
 	struct usmbd_share *share = entry;
 	int ret;
 
 	dce->num_pointers++;
-	ret = ndr_write_int32(dce, dce->num_pointers); /* ref pointer */
+	ret = ndr_write_int32(dce, dce->num_pointers);	/* ref pointer */
 	ret |= ndr_write_int32(dce, __share_type(share));
 	dce->num_pointers++;
-	ret |= ndr_write_int32(dce, dce->num_pointers); /* ref pointer */
+	ret |= ndr_write_int32(dce, dce->num_pointers);	/* ref pointer */
 	return ret;
 }
 
-static int __share_entry_data_ctr0(struct usmbd_dcerpc *dce, gpointer entry)
+static int __share_entry_data_ctr0(struct usmbd_dcerpc *dce, void *entry)
 {
 	struct usmbd_share *share = entry;
 
 	return ndr_write_vstring(dce, share->name);
 }
 
-static int __share_entry_data_ctr1(struct usmbd_dcerpc *dce, gpointer entry)
+static int __share_entry_data_ctr1(struct usmbd_dcerpc *dce, void *entry)
 {
 	struct usmbd_share *share = entry;
 	int ret;
@@ -107,20 +106,18 @@ static int __share_entry_data_ctr1(struc
 	return ret;
 }
 
-static int __share_entry_null_rep_ctr0(struct usmbd_dcerpc *dce,
-				       gpointer entry)
+static int __share_entry_null_rep_ctr0(struct usmbd_dcerpc *dce, void *entry)
 {
-	return ndr_write_int32(dce, 0); /* ref pointer */
+	return ndr_write_int32(dce, 0);	/* ref pointer */
 }
 
-static int __share_entry_null_rep_ctr1(struct usmbd_dcerpc *dce,
-				       gpointer entry)
+static int __share_entry_null_rep_ctr1(struct usmbd_dcerpc *dce, void *entry)
 {
 	int ret;
 
-	ret = ndr_write_int32(dce, 0); /* ref pointer */
+	ret = ndr_write_int32(dce, 0);	/* ref pointer */
 	ret |= ndr_write_int32(dce, 0);
-	ret |= ndr_write_int32(dce, 0); /* ref pointer */
+	ret |= ndr_write_int32(dce, 0);	/* ref pointer */
 	return ret;
 }
 
@@ -128,8 +125,9 @@ static int __share_entry_processed(struc
 {
 	struct usmbd_share *share;
 
-	share = g_array_index(pipe->entries,  gpointer, i);
-	pipe->entries = g_array_remove_index(pipe->entries, i);
+	share = list_get(&pipe->entries, i);
+
+	list_remove_dec(&pipe->entries, i);
 	pipe->num_entries--;
 	pipe->num_processed++;
 	put_usmbd_share(share);
@@ -137,7 +135,8 @@ static int __share_entry_processed(struc
 	return 0;
 }
 
-static void __enum_all_shares(gpointer key, gpointer value, gpointer user_data)
+static void __enum_all_shares(void *value, unsigned long long id,
+			      void *user_data)
 {
 	struct usmbd_rpc_pipe *pipe = (struct usmbd_rpc_pipe *)user_data;
 	struct usmbd_share *share = (struct usmbd_share *)value;
@@ -154,14 +153,13 @@ static void __enum_all_shares(gpointer k
 		put_usmbd_share(share);
 		return;
 	}
-
-	pipe->entries = g_array_append_val(pipe->entries, share);
+	list_append(&pipe->entries, share);
 	pipe->num_entries++;
 }
 
 static int srvsvc_share_enum_all_invoke(struct usmbd_rpc_pipe *pipe)
 {
-	for_each_usmbd_share(__enum_all_shares, pipe);
+	foreach_usmbd_share(__enum_all_shares, pipe);
 	pipe->entry_processed = __share_entry_processed;
 	return 0;
 }
@@ -199,7 +197,7 @@ static int srvsvc_share_get_info_invoke(
 		}
 	}
 
-	pipe->entries = g_array_append_val(pipe->entries, share);
+	list_append(&pipe->entries, share);
 	pipe->num_entries++;
 	pipe->entry_processed = __share_entry_processed;
 	return 0;
@@ -253,7 +251,7 @@ static int srvsvc_share_get_info_return(
 		dce->entry_rep = __share_entry_null_rep_ctr1;
 	} else {
 		pr_err("Unsupported share info level (read): %d\n",
-			dce->si_req.level);
+		       dce->si_req.level);
 		dce->entry_rep = NULL;
 		return USMBD_RPC_EINVALID_LEVEL;
 	}
@@ -277,13 +275,12 @@ static int srvsvc_parse_share_info_req(s
 		hdr->level = ndr_read_union_int32(dce);
 		if (hdr->level == -EINVAL)
 			return -EINVAL;
-		ndr_read_int32(dce); // read container pointer ref id
-		ndr_read_int32(dce); // read container array size
-		ptr = ndr_read_int32(dce); // read container array pointer
-					   // it should be null
+		ndr_read_int32(dce);	// read container pointer ref id
+		ndr_read_int32(dce);	// read container array size
+		ptr = ndr_read_int32(dce);	// read container array pointer
+		// it should be null
 		if (ptr != 0x00) {
-			pr_err("SRVSVC: container array pointer is %x\n",
-				ptr);
+			pr_err("SRVSVC: container array pointer is %x\n", ptr);
 			return -EINVAL;
 		}
 		hdr->max_size = ndr_read_int32(dce);
@@ -320,8 +317,7 @@ static int srvsvc_share_info_invoke(stru
 	return ret;
 }
 
-static int srvsvc_clear_headers(struct usmbd_rpc_pipe *pipe,
-				int status)
+static int srvsvc_clear_headers(struct usmbd_rpc_pipe *pipe, int status)
 {
 	if (status == USMBD_RPC_EMORE_DATA)
 		return 0;
@@ -358,12 +354,13 @@ static int srvsvc_share_info_return(stru
 		dce->entry_data = __share_entry_data_ctr1;
 	} else {
 		pr_err("Unsupported share info level (write): %d\n",
-			dce->si_req.level);
+		       dce->si_req.level);
 		rpc_pipe_reset(pipe);
 	}
 
 	if (dce->req_hdr.opnum == SRVSVC_OPNUM_GET_SHARE_INFO)
 		status = srvsvc_share_get_info_return(pipe);
+
 	if (dce->req_hdr.opnum == SRVSVC_OPNUM_SHARE_ENUM_ALL)
 		status = srvsvc_share_enum_all_return(pipe);
 
@@ -404,8 +401,7 @@ static int srvsvc_invoke(struct usmbd_rp
 }
 
 static int srvsvc_return(struct usmbd_rpc_pipe *pipe,
-			 struct usmbd_rpc_command *resp,
-			 int max_resp_sz)
+			 struct usmbd_rpc_command *resp, int max_resp_sz)
 {
 	struct usmbd_dcerpc *dce = pipe->dce;
 	int ret;
@@ -422,7 +418,7 @@ static int srvsvc_return(struct usmbd_rp
 		break;
 	default:
 		pr_err("SRVSVC: unsupported RETURN method %d\n",
-			dce->req_hdr.opnum);
+		       dce->req_hdr.opnum);
 		ret = USMBD_RPC_EBAD_FUNC;
 		break;
 	}
@@ -430,8 +426,7 @@ static int srvsvc_return(struct usmbd_rp
 }
 
 int rpc_srvsvc_read_request(struct usmbd_rpc_pipe *pipe,
-			    struct usmbd_rpc_command *resp,
-			    int max_resp_sz)
+			    struct usmbd_rpc_command *resp, int max_resp_sz)
 {
 	return srvsvc_return(pipe, resp, max_resp_sz);
 }
diff -urpN ksmbd-tools-3.1.0/usmbd/rpc_wkssvc.c ksmbd-tools-3.1.0.new/usmbd/rpc_wkssvc.c
--- ksmbd-tools-3.1.0/usmbd/rpc_wkssvc.c	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/usmbd/rpc_wkssvc.c	2020-01-25 02:01:29.299043469 +0400
@@ -7,7 +7,6 @@
 
 #include <memory.h>
 #include <endian.h>
-#include <glib.h>
 #include <errno.h>
 #include <linux/usmbd_server.h>
 
@@ -36,7 +35,7 @@ static int wkssvc_clear_headers(struct u
 }
 
 static int __netwksta_entry_rep_ctr100(struct usmbd_dcerpc *dce,
-				       gpointer entry)
+				       void *entry)
 {
 	int ret = 0;
 
@@ -58,7 +57,7 @@ static int __netwksta_entry_rep_ctr100(s
 }
 
 static int __netwksta_entry_data_ctr100(struct usmbd_dcerpc *dce,
-					gpointer entry)
+					void *entry)
 {
 	int ret = 0;
 
diff -urpN ksmbd-tools-3.1.0/usmbd/usmbd.c ksmbd-tools-3.1.0.new/usmbd/usmbd.c
--- ksmbd-tools-3.1.0/usmbd/usmbd.c	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/usmbd/usmbd.c	2020-01-26 13:58:13.876726005 +0400
@@ -30,7 +30,7 @@
 #include <management/session.h>
 #include <management/tree_conn.h>
 
-static int no_detach = 0;
+static int no_detach;
 int usmbd_health_status;
 static pid_t worker_pid;
 static int lock_fd = -1;
@@ -216,15 +216,15 @@ static void worker_process_free(void)
 	 */
 	ipc_destroy();
 	rpc_destroy();
-	wp_destroy();
 	sm_destroy();
+	wp_destroy();
 	shm_destroy();
 	usm_destroy();
 }
 
 static void child_sig_handler(int signo)
 {
-	static volatile int fatal_delivered = 0;
+	static volatile int fatal_delivered;
 
 	if (signo == SIGHUP) {
 		/*
@@ -240,7 +240,7 @@ static void child_sig_handler(int signo)
 	pr_err("Child received signal: %d (%s)\n",
 		signo, strsignal(signo));
 
-	if (!g_atomic_int_compare_and_exchange(&fatal_delivered, 0, 1))
+	if (!atomic_int_compare_and_exchange(&fatal_delivered, 0, 1))
 		return;
 
 	usmbd_health_status &= ~USMBD_HEALTH_RUNNING;
@@ -296,13 +296,16 @@ static int worker_process_init(void)
 
 	setup_signals(child_sig_handler);
 	set_logger_app_name("usmbd-worker");
-
 	ret = usm_init();
 	if (ret) {
 		pr_err("Failed to init user management\n");
 		goto out;
 	}
-
+	ret = wp_init();
+	if (ret) {
+		pr_err("Failed to init worker\n");
+		goto out;
+	}
 	ret = shm_init();
 	if (ret) {
 		pr_err("Failed to init net share management\n");
@@ -321,12 +324,6 @@ static int worker_process_init(void)
 		goto out;
 	}
 
-	ret = wp_init();
-	if (ret) {
-		pr_err("Failed to init worker threads pool\n");
-		goto out;
-	}
-
 	ret = rpc_init();
 	if (ret) {
 		pr_err("Failed to init RPC subsystem\n");
@@ -495,10 +492,10 @@ int main(int argc, char *argv[])
 			pr_debug("TCP port option override\n");
 			break;
 		case 'c':
-			smbconf = g_strdup(optarg);
+			smbconf = strdup(optarg);
 			break;
 		case 'u':
-			pwddb = g_strdup(optarg);
+			pwddb = strdup(optarg);
 			break;
 		case 'n':
 			if (!optarg)
diff -urpN ksmbd-tools-3.1.0/usmbd/worker.c ksmbd-tools-3.1.0.new/usmbd/worker.c
--- ksmbd-tools-3.1.0/usmbd/worker.c	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/usmbd/worker.c	2020-01-26 13:58:13.876726005 +0400
@@ -5,7 +5,8 @@
  *   linux-cifsd-devel@lists.sourceforge.net
  */
 #include <memory.h>
-#include <glib.h>
+#include <pthread.h>
+#include <semaphore.h>
 #include <errno.h>
 #include <linux/usmbd_server.h>
 
@@ -19,7 +20,7 @@
 #include <management/tree_conn.h>
 
 #define MAX_WORKER_THREADS	4
-static GThreadPool *pool;
+static sem_t semaphore;
 
 #define VALID_IPC_MSG(m, t)					\
 	({							\
@@ -156,7 +157,7 @@ static int rpc_request(struct usmbd_ipc_
 	req = USMBD_IPC_MSG_PAYLOAD(msg);
 	if (req->flags & USMBD_RPC_METHOD_RETURN)
 		resp_msg = ipc_msg_alloc(USMBD_IPC_MAX_MESSAGE_SIZE -
-				sizeof(struct usmbd_rpc_command));
+					 sizeof(struct usmbd_rpc_command));
 	else
 		resp_msg = ipc_msg_alloc(sizeof(struct usmbd_rpc_command));
 	if (!resp_msg)
@@ -193,7 +194,7 @@ out:
 	return 0;
 }
 
-static void worker_pool_fn(gpointer event, gpointer user_data)
+static void *worker_pool_fn(void *event)
 {
 	struct usmbd_ipc_msg *msg = (struct usmbd_ipc_msg *)event;
 
@@ -232,38 +233,35 @@ static void worker_pool_fn(gpointer even
 	}
 
 	ipc_msg_free(msg);
+	sem_post(&semaphore);
+	return NULL;
 }
 
 int wp_ipc_msg_push(struct usmbd_ipc_msg *msg)
 {
-	return g_thread_pool_push(pool, msg, NULL);
-}
+	pthread_attr_t attr;
+	pthread_t thread;
+
+	sem_wait(&semaphore);
+	pthread_attr_init(&attr);
+	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
+	if (pthread_create(&thread, &attr, worker_pool_fn, msg) != 0) {
+		pthread_attr_destroy(&attr);
+		sem_post(&semaphore);
+		pr_err("error while creating worker thread\n");
+		return -1;
+	}
+	pthread_attr_destroy(&attr);
+	return 0;
 
-void wp_destroy(void)
-{
-	if (pool)
-		g_thread_pool_free(pool, 1, 1);
 }
 
 int wp_init(void)
 {
-	GError *err;
-
-	pool = g_thread_pool_new(worker_pool_fn,
-				 NULL,
-				 MAX_WORKER_THREADS,
-				 0,
-				 &err);
-	if (!pool) {
-		if (err) {
-			pr_err("Can't create pool: %s\n", err->message);
-			g_error_free(err);
-		}
-		goto out_error;
-	}
+	return sem_init(&semaphore, 0, MAX_WORKER_THREADS);
+}
 
-	return 0;
-out_error:
-	wp_destroy();
-	return -ENOMEM;
+void wp_destroy(void)
+{
+	sem_destroy(&semaphore);
 }
